org.apache.lucene.analysis

## Class ASCIIFoldingFilter

- java.lang.Object
- - org.apache.lucene.util.AttributeSource
  - - org.apache.lucene.analysis.TokenStream
    - - org.apache.lucene.analysis.TokenFilter
      - - org.apache.lucene.analysis.ASCIIFoldingFilter

-     public final class ASCIIFoldingFilter
      extends TokenFilter

  This class converts alphabetic, numeric, and symbolic Unicode characters which are not in the first 127 ASCII characters (the "Basic Latin" Unicode block) into their ASCII equivalents, if one exists. Characters from the following Unicode blocks are converted; however, only those characters with reasonable ASCII alternatives are converted:
  - C1 Controls and Latin-1 Supplement: http://www.unicode.org/charts/PDF/U0080.pdf
  - Latin Extended-A: http://www.unicode.org/charts/PDF/U0100.pdf
  - Latin Extended-B: http://www.unicode.org/charts/PDF/U0180.pdf
  - Latin Extended Additional: http://www.unicode.org/charts/PDF/U1E00.pdf
  - Latin Extended-C: http://www.unicode.org/charts/PDF/U2C60.pdf
  - Latin Extended-D: http://www.unicode.org/charts/PDF/UA720.pdf
  - IPA Extensions: http://www.unicode.org/charts/PDF/U0250.pdf
  - Phonetic Extensions: http://www.unicode.org/charts/PDF/U1D00.pdf
  - Phonetic Extensions Supplement: http://www.unicode.org/charts/PDF/U1D80.pdf
  - General Punctuation: http://www.unicode.org/charts/PDF/U2000.pdf
  - Superscripts and Subscripts: http://www.unicode.org/charts/PDF/U2070.pdf
  - Enclosed Alphanumerics: http://www.unicode.org/charts/PDF/U2460.pdf
  - Dingbats: http://www.unicode.org/charts/PDF/U2700.pdf
  - Supplemental Punctuation: http://www.unicode.org/charts/PDF/U2E00.pdf
  - Alphabetic Presentation Forms: http://www.unicode.org/charts/PDF/UFB00.pdf
  - Halfwidth and Fullwidth Forms: http://www.unicode.org/charts/PDF/UFF00.pdf
  See: http://en.wikipedia.org/wiki/Latin_characters_in_Unicode The set of character conversions supported by this class is a superset of those supported by Lucene's `ISOLatin1AccentFilter` which strips accents from Latin1 characters. For example, 'à' will be replaced by 'a'.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.util.AttributeSource

      `AttributeSource.AttributeFactory, AttributeSource.State`

  - ### Field Summary

    - ### Fields inherited from class org.apache.lucene.analysis.TokenFilter

      `input`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ASCIIFoldingFilter(TokenStream input)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `foldToASCII(char[] input, int length)` Converts characters above ASCII to their ASCII equivalents.
    `boolean` | `incrementToken()` Consumers (i.e., `IndexWriter`) use this method to advance the stream to the next token.

    - ### Methods inherited from class org.apache.lucene.analysis.TokenFilter

      `close, end, reset`

    - ### Methods inherited from class org.apache.lucene.analysis.TokenStream

      `getOnlyUseNewAPI, next, next, setOnlyUseNewAPI`

    - ### Methods inherited from class org.apache.lucene.util.AttributeSource

      `addAttribute, addAttributeImpl, captureState, clearAttributes, cloneAttributes, equals, getAttribute, getAttributeClassesIterator, getAttributeFactory, getAttributeImplsIterator, hasAttribute, hasAttributes, hashCode, restoreState, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ASCIIFoldingFilter

          public ASCIIFoldingFilter(TokenStream input)

  - ### Method Detail

    - #### incrementToken

          public boolean incrementToken()
                                 throws java.io.IOException

      Description copied from class: `TokenStream`
      Consumers (i.e., `IndexWriter`) use this method to advance the stream to the next token. Implementing classes must implement this method and update the appropriate `AttributeImpl`s with the attributes of the next token.

      The producer must make no assumptions about the attributes after the method has been returned: the caller may arbitrarily change it. If the producer needs to preserve the state for subsequent calls, it can use `AttributeSource.captureState()` to create a copy of the current attribute state.

      This method is called for every token of a document, so an efficient implementation is crucial for good performance. To avoid calls to `AttributeSource.addAttribute(Class)` and `AttributeSource.getAttribute(Class)` or downcasts, references to all `AttributeImpl`s that this stream uses should be retrieved during instantiation.

      To ensure that filters and consumers know which attributes are available, the attributes must be added during instantiation. Filters and consumers are not required to check for availability of attributes in `TokenStream.incrementToken()`.

      Overrides:
        `incrementToken` in class `TokenStream`
      Returns:
        false for end of stream; true otherwise

        Note that this method will be defined abstract in Lucene 3.0.

      Throws:
        `java.io.IOException`

    - #### foldToASCII

          public void foldToASCII(char[] input,
                                  int length)

      Converts characters above ASCII to their ASCII equivalents. For example, accents are removed from accented characters.
      Parameters:
        `input` - The string to fold
        `length` - The number of characters in the input string

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.